﻿using CompiledQueriesCSharp;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Linq;
using EntityDataModel;
using LINQtoSQLClasses;

namespace TestProject1
{
    
    
    /// <summary>
    ///This is a test class for DataRetrievalTest and is intended
    ///to contain all DataRetrievalTest Unit Tests
    ///</summary>
  [TestClass()]
  public class DataRetrievalTest
  {


    private TestContext testContextInstance;

    /// <summary>
    ///Gets or sets the test context which provides
    ///information about and functionality for the current test run.
    ///</summary>
    public TestContext TestContext
    {
      get
      {
        return testContextInstance;
      }
      set
      {
        testContextInstance = value;
      }
    }

    #region Additional test attributes
    // 
    //You can use the following additional attributes as you write your tests:
    //
    //Use ClassInitialize to run code before running the first test in the class
    //[ClassInitialize()]
    //public static void MyClassInitialize(TestContext testContext)
    //{
    //}
    //
    //Use ClassCleanup to run code after all tests in a class have run
    //[ClassCleanup()]
    //public static void MyClassCleanup()
    //{
    //}
    //
    //Use TestInitialize to run code before running each test
    //[TestInitialize()]
    //public void MyTestInitialize()
    //{
    //}
    //
    //Use TestCleanup to run code after each test has run
    //[TestCleanup()]
    //public void MyTestCleanup()
    //{
    //}
    //
    #endregion


    ///note: these simplistic integration tests require debugging to determine if compilation
    ///is executed more than once

    /// <summary>
    ///A test for GetCustomerSales
    ///</summary>
    [TestMethod()]
    public void DebugToVerifyCompilation()
    {
      
      DataRetrievalEF target = new DataRetrievalEF(); // TODO: Initialize to an appropriate value
      IQueryable<CustomerSales> actual;
      actual = target.GetCustomerSales();
      DataRetrievalEF target2 = new DataRetrievalEF(); // TODO: Initialize to an appropriate value
      actual = target2.GetCustomerSales();
      Assert.Inconclusive("Validation happens in debug - does compile get called on target2 call?");
    }

    /// <summary>
    ///A test for GetCustomer
    ///</summary>
    [TestMethod()]
    public void GetCustomerTest()
    {
      DataRetrievalEF target = new DataRetrievalEF(); // TODO: Initialize to an appropriate value
      int ID = 1; // TODO: Initialize to an appropriate value
      EntityDataModel.Customer actual;
      actual = target.GetCustomer(ID);
      DataRetrievalEF target2 = new DataRetrievalEF();
      actual = target2.GetCustomer(ID);
      Assert.Inconclusive("Validation happens in debug - does compile get called on target2 call?");
    }
    [TestMethod()]
    public void GetCustomerWithOrdersTest()
    {
      DataRetrievalEF target = new DataRetrievalEF(); // TODO: Initialize to an appropriate value
      EntityDataModel.Customer actual;
      actual = target.GetRandomCustomerWithOrders();
      DataRetrievalEF target2 = new DataRetrievalEF();
      actual = target2.GetRandomCustomerWithOrders();
      Assert.IsTrue(actual.Orders.Count>0);
    }

    [TestMethod()]
    public void DebugToVerifyCompilationL2S()
    {

      DataRetrievalL2S target = new DataRetrievalL2S(); // TODO: Initialize to an appropriate value
      IQueryable<CustomerSalesStruct> actual;
      actual = target.GetCustomerSales();
      DataRetrievalL2S target2 = new DataRetrievalL2S(); // TODO: Initialize to an appropriate value
      actual = target2.GetCustomerSales();
      Assert.Inconclusive("Validation happens in debug - does compile get called on target2 call?");
    }

    /// <summary>
    ///A test for GetCustomer
    ///</summary>
    [TestMethod()]
    public void GetCustomerTestL2S()
    {
      DataRetrievalL2S target = new DataRetrievalL2S(); // TODO: Initialize to an appropriate value
      int ID = 1; // TODO: Initialize to an appropriate value
      LINQtoSQLClasses.Customer actual;
      actual = target.GetCustomer(ID);
      DataRetrievalL2S target2 = new DataRetrievalL2S();
      actual = target2.GetCustomer(ID);
      Assert.Inconclusive("Validation happens in debug - does compile get called on target2 call?");
    }

    [TestMethod()]
    public void GetCustomerWithOrdersL2S()
    {
      DataRetrievalL2S target = new DataRetrievalL2S();
      LINQtoSQLClasses.Customer actual;
      actual = target.GetRandomCustomerWithOrders();
      DataRetrievalL2S target2 = new DataRetrievalL2S();
      actual = target2.GetRandomCustomerWithOrders();
      Assert.IsTrue(actual.Orders.HasLoadedOrAssignedValues);
    }

     [TestMethod()]
    public void IsolatedLoadOptions()
    {
      DataRetrievalL2S target = new DataRetrievalL2S();
      int ID = 6; // customer with id 6 has orders
      LINQtoSQLClasses.Customer actual;
      actual = target.GetRandomCustomerWithOrders();
      DataRetrievalL2S target2 = new DataRetrievalL2S();
      actual = target2.GetCustomer(ID);
      Assert.IsTrue(actual.Orders.Count == 0);

    }
     [TestMethod()]
     public void GetMultipleCustomerWithOrdersTest()
     {
       DataRetrievalL2S target = new DataRetrievalL2S(); 
       //IQueryable<LINQtoSQLClasses.Customer> actual;
       LINQtoSQLClasses.Customer actual;
       actual = target.GetMultipleCustomerWithOrders();
       Assert.Inconclusive("Verify the correctness of this test method.");
     }
     [TestMethod()]
     public void SimpleQueryCustomerPreFecth()
     {
       DataRetrievalL2S target = new DataRetrievalL2S();
       //IQueryable<LINQtoSQLClasses.Customer> actual;
     //  actual = target.SimpleQuery();
       target = new DataRetrievalL2S();
       var actuallist = target.SimpleQueryManyItems();
       Assert.Inconclusive("Verify the correctness of this test method.");
     } 
  }
}
